////////////////////////////////////////////////////////////////////////////
// CEditCommand 饹Υץơ
//
////////////////////////////////////////////////////////////////////////////

#include "TaEdit_std.h"
#include "EditCommand.h"

////////////////////////////////////////////////////////////////////////////
// /˴
////////////////////////////////////////////////////////////////////////////

CEditCommand::CEditCommand( enumTEC_TYPE argType ) :
	type( argType ), CCPInterface()
{
	BeforeSelRange = T_SelRange( 0, 0 );
	AfterSelRange = T_SelRange( 0, 0 );
	BeforeCurPos = T_CurPos( 0, 0 );
	AfterCurPos = T_CurPos( 0, 0 );
	InsertPos = T_CurPos( 0, 0 );
	DeleteRange = T_SelRange( 0, 0 );
	EditString = L"";
}

CEditCommand::~CEditCommand()
{

}

////////////////////////////////////////////////////////////////////////////
// ᥽å
////////////////////////////////////////////////////////////////////////////

// Υ֥Ȥ򥿥פ
enumTEC_TYPE CEditCommand::GetType() const
{
	assert( NULL != this );
	return type;
}

// ԽΥ֡ϰϤ
void CEditCommand::SetCurPos_SelRange( const T_SelRange& argBSR, const T_CurPos& argBCP, const T_SelRange& argASR, const T_CurPos& argACP )
{
	assert( NULL != this );
	BeforeSelRange = argBSR;
	BeforeCurPos = argBCP;
	AfterSelRange = argASR;
	AfterCurPos = argACP;
}

// ϰϤȥƥȤ
void CEditCommand::SetDeleteInfo( const T_SelRange& argRange, const wstring &argStr )
{
	assert( NULL != this && type == TEC_DELETE );
	DeleteRange = argRange;
	EditString = argStr;
}

// ֤ȥƥȤ
void CEditCommand::SelInsertInfo( const T_CurPos &argPos, const wstring &argStr )
{
	assert( NULL != this && type == TEC_INSERT );
	InsertPos = argPos;
	EditString = argStr;

}

// ԽΥ֡ϰϤ
const T_SelRange& CEditCommand::GetBeforeSelRange() const
{
	assert( NULL != this );
	return BeforeSelRange;
}

const T_CurPos& CEditCommand::GetBeforeCurPos() const
{
	assert( NULL != this );
	return BeforeCurPos;
}

const T_SelRange& CEditCommand::GetAfterSelRange() const
{
	assert( NULL != this );
	return AfterSelRange;
}

const T_CurPos& CEditCommand::GetAfterCurPos() const
{
	assert( NULL != this );
	return AfterCurPos;
}

// ƥ֤
const T_CurPos& CEditCommand::GetInsertPos() const
{
	assert( NULL != this && type == TEC_INSERT );
	return InsertPos;
}

// ƥȤ
const wstring& CEditCommand::GetInsertText() const
{
	assert( NULL != this && type == TEC_INSERT );
	return EditString;
}

// ϰϤ
const T_SelRange& CEditCommand::GetDeleteRange() const
{
	assert( NULL != this && type == TEC_DELETE );
	return DeleteRange;
}

// ƥȤ
const wstring& CEditCommand::GetDeleteText() const
{
	assert( NULL != this && type == TEC_DELETE );
	return EditString;
}

