////////////////////////////////////////////////////////////////////////////
// CGCStorage 饹Υץơ
//
////////////////////////////////////////////////////////////////////////////

#include "TaEdit_std.h"
#include "GCStorage.h"

////////////////////////////////////////////////////////////////////////////
// /˴
////////////////////////////////////////////////////////////////////////////

CGCStorage::CGCStorage() :
	mapGC(),
	CCPInterface()
{

}

CGCStorage::~CGCStorage()
{
	FreeGC();
}

////////////////////////////////////////////////////////////////////////////
// ᥽å
////////////////////////////////////////////////////////////////////////////

// GCۤ
bool CGCStorage::CreateGC( int id, Widget wgt, Pixel fg, Pixel bg )
{
	Display *d = XtDisplay( wgt );
	Window window = XtWindow( wgt );
	map< int, pair< GC, Widget > >::iterator itr;
	GC gc;

	// ƱIDʪǤ¸ߤƤ뤫ݤǧ
	itr = mapGC.find( id );

	if ( itr == mapGC.end() ) {
		// ¸ΤΤ¸ߤʤäGCۤ
		gc = XCreateGC( d, window, 0, NULL );
		if ( NULL == gc ) return false;
	}
	else {
		// ¸ʪ¸ߤϡѤ
		gc = itr->second.first;
	}

	// ꤹ
	XSetForeground( d, gc, fg );
	XSetBackground( d, gc, bg );
	XSetLineAttributes( d, gc, 0, LineSolid, CapButt, JoinBevel );

	// mapɲä
	if ( itr == mapGC.end() ) {
		pair< int, pair< GC, Widget > > wPair( id, pair< GC, Widget >( gc, wgt ) );
		mapGC.insert( wPair );
	}
	return true;
}

// GC
GC CGCStorage::GetGC( int id ) const
{
	map< int, pair< GC, Widget > >::const_iterator itr;
	itr = mapGC.find( id );
	if ( itr == mapGC.end() )
		return NULL;
	else
		return itr->second.first;
}

// ƤGC
void CGCStorage::FreeGC()
{
	map< int, pair< GC, Widget > >::iterator itr;

	itr = mapGC.begin();
	for (; itr != mapGC.end(); itr++ ) {
		Display *pDisplay = XtDisplay( itr->second.second );
		XFreeGC( pDisplay, itr->second.first );
	}	
	mapGC.clear();
}


